package artik.bowfix;

import artik.bowfix.listeners.Handler;
import artik.bowfix.listeners.ItemUseEvent;
import artik.bowfix.listeners.PlayerTPEvent;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.util.logging.Logger;

public final class BowFix extends JavaPlugin
{
    public static BowFix instance;
    
    public static final Logger LOG = Logger.getLogger("Minecraft");
    
    @Override
    public void onEnable()
    {
        // Plugin startup logic
    
        LOG.info("Loading plugin [BowFix] ...");
       
        instance = this;
        
        LOG.info("Creating folder ...");
        File file = new File("plugins/BowExploitFixer");
    
        boolean flag = file.mkdir();
        if(flag) LOG.info("Folder had been create!");
        else LOG.warning("Folder hadn't been create! WARNING");
    
        LOG.info("Creating warning count..");
    
        File config = new File("plugins/BowExploitFixer/config.yml");
        File count = new File("plugins/BowExploitFixer/count.db");
    
        if(!config.exists())
        {
            getConfig().options().copyDefaults(true);
            saveDefaultConfig();
        }
    
        getServer().getPluginManager().registerEvents(new Handler(), this);
        getServer().getPluginManager().registerEvents(new ItemUseEvent(), this);
        getServer().getPluginManager().registerEvents(new PlayerTPEvent(), this);
    
        LOG.info("Plugin [BowFix] was loaded successfully!");
    }
    
    @Override
    public void onDisable()
    {
        // Plugin shutdown logic
    
        LOG.info("Disabling plugin [BowFix] ...");
        LOG.info("Saving classes...");
    
        LOG.info("Saving dates...");
        LOG.info("Plugin [BowFix] was disabled successfully!");
    }
}
